#ifndef SC_MODULE_H
#define SC_MODULE_H


#include <sc_sensitive.h>
#include <sc_module_name.h>
#include <sc_signal.h>

namespace sc_core
{

class sc_module
{
    public:

    // Constructors

    sc_module();
    sc_module(const sc_module_name&);

    void reset_signal_is( const sc_in<bool>& , bool );
    void reset_signal_is( const sc_signal<bool>& , bool );

    void wait();

    void dont_initialize();
/*
    void operator()(const sc_bind_proxy&,
               const sc_bind_proxy& = SC_BIND_PROXY_NIL,
               const sc_bind_proxy& = SC_BIND_PROXY_NIL,
               const sc_bind_proxy& = SC_BIND_PROXY_NIL,
               const sc_bind_proxy& = SC_BIND_PROXY_NIL,
               const sc_bind_proxy& = SC_BIND_PROXY_NIL,
               const sc_bind_proxy& = SC_BIND_PROXY_NIL,
               const sc_bind_proxy& = SC_BIND_PROXY_NIL,
               const sc_bind_proxy& = SC_BIND_PROXY_NIL,
               const sc_bind_proxy& = SC_BIND_PROXY_NIL,
               const sc_bind_proxy& = SC_BIND_PROXY_NIL,
               const sc_bind_proxy& = SC_BIND_PROXY_NIL,
               const sc_bind_proxy& = SC_BIND_PROXY_NIL,
               const sc_bind_proxy& = SC_BIND_PROXY_NIL,
               const sc_bind_proxy& = SC_BIND_PROXY_NIL,
               const sc_bind_proxy& = SC_BIND_PROXY_NIL,
               const sc_bind_proxy& = SC_BIND_PROXY_NIL,
               const sc_bind_proxy& = SC_BIND_PROXY_NIL,
               const sc_bind_proxy& = SC_BIND_PROXY_NIL,
               const sc_bind_proxy& = SC_BIND_PROXY_NIL,
               const sc_bind_proxy& = SC_BIND_PROXY_NIL,
               const sc_bind_proxy& = SC_BIND_PROXY_NIL,
               const sc_bind_proxy& = SC_BIND_PROXY_NIL,
               const sc_bind_proxy& = SC_BIND_PROXY_NIL,
               const sc_bind_proxy& = SC_BIND_PROXY_NIL,
               const sc_bind_proxy& = SC_BIND_PROXY_NIL,
               const sc_bind_proxy& = SC_BIND_PROXY_NIL,
               const sc_bind_proxy& = SC_BIND_PROXY_NIL,
               const sc_bind_proxy& = SC_BIND_PROXY_NIL,
               const sc_bind_proxy& = SC_BIND_PROXY_NIL,
               const sc_bind_proxy& = SC_BIND_PROXY_NIL,
               const sc_bind_proxy& = SC_BIND_PROXY_NIL,
               const sc_bind_proxy& = SC_BIND_PROXY_NIL);*/
;

private:

    // Disabled

    sc_module( const sc_module& );
    sc_module& operator=(const sc_module&);
};

// -----------------------------------------------------------------------------
// SOME MACROS TO SIMPLIFY SYNTAX:
// -----------------------------------------------------------------------------

#define SC_MODULE(user_module_name)                                           \
    struct user_module_name : ::sc_core::sc_module

#define SC_CTOR(user_module_name)                                             \
    typedef user_module_name SC_CURRENT_USER_MODULE;                          \
    private:                                                                  \
    user_module_name(const user_module_name&);                                \
    user_module_name& operator = (const user_module_name&);                   \
    public:                                                                   \
    user_module_name( ::sc_core::sc_module_name )

// the SC_HAS_PROCESS macro call must be followed by a ;
#define SC_HAS_PROCESS(user_module_name)                                      \
    typedef user_module_name SC_CURRENT_USER_MODULE

//-----------------------------------------------------------------------------
// PROCESS DECLARATION
//-----------------------------------------------------------------------------

template <class T>
void sc_thread(T* pobject, void (T::* pmethod)());

template <class T>
void sc_method(T* pobject, void (T::* pmethod)());


#define SC_CTHREAD(handle, edge)                                              \
{                                                                             \
    sc_cthread<SC_CURRENT_USER_MODULE>(this, &SC_CURRENT_USER_MODULE::handle);\
    sensitive << (edge);                                                      \
}                                                                             \

#define SC_THREAD(handle)                                                     \
{                                                                             \
    sc_thread<SC_CURRENT_USER_MODULE>(this, &SC_CURRENT_USER_MODULE::handle);\
}

#define SC_METHOD(handle)                                                     \
{                                                                             \
    sc_method<SC_CURRENT_USER_MODULE>(this, &SC_CURRENT_USER_MODULE::handle);\
}                                                                             \

} // namespace sc_core

#endif
